[hdu4358]树状数组

思路:用一个数组记录最近k次的出现位置,然后在其附近更新答案。具体见代码:

  1 #pragma comment(linker, "/STACK:10240000,10240000")
  2
  3 #include <iostream>
  4 #include <cstdio>
  5 #include <algorithm>
  6 #include <cstdlib>
  7 #include <cstring>
  8 #include <map>
  9 #include <queue>
 10 #include <deque>
 11 #include <cmath>
 12 #include <vector>
 13 #include <ctime>
 14 #include <cctype>
 15 #include <set>
 16
 17 using namespace std;
 18
 19 #define mem0(a) memset(a, 0, sizeof(a))
 20 #define lson l, m, rt << 1
 21 #define rson m + 1, r, rt << 1 | 1
 22 #define define_m int m = (l + r) >> 1
 23 #define Rep(a, b) for(int a = 0; a < b; a++)
 24 #define lowbit(x) ((x) & (-(x)))
 25 #define constructInt4(name, a, b, c, d) name(int a = 0, int b = 0, int c = 0, int d = 0): a(a), b(b), c(c), d(d) {}
 26 #define constructInt3(name, a, b, c) name(int a = 0, int b = 0, int c = 0): a(a), b(b), c(c) {}
 27 #define constructInt2(name, a, b) name(int a = 0, int b = 0): a(a), b(b) {}
 28
 29 typedef double db;
 30 typedef long long LL;
 31 typedef pair<int, int> pii;
 32 typedef multiset<int> msi;
 33 typedef multiset<int>::iterator msii;
 34 typedef set<int> si;
 35 typedef set<int>::iterator sii;
 36 typedef vector<int> vi;
 37
 38 const int dx[8] = {1, 0, -1, 0, 1, 1, -1, -1};
 39 const int dy[8] = {0, -1, 0, 1, -1, 1, 1, -1};
 40 const int maxn = 1e5 + 7;
 41 const int maxm = 1e5 + 7;
 42 const int maxv = 1e7 + 7;
 43 const int MD = 1e9 +7;
 44 const int INF = 1e9 + 7;
 45 const double PI = acos(-1.0);
 46 const double eps = 1e-10;
 47
 48 template<class edge> struct Graph {
 49     vector<vector<edge> > adj;
 50     Graph(int n) { adj.clear(); adj.resize(n + 5); }
 51     Graph() { adj.clear(); }
 52     void resize(int n) { adj.resize(n + 5); }
 53     void add(int s, edge e){ adj[s].push_back(e); }
 54     void del(int s, edge e) { adj[s].erase(find(iter(adj[s]), e)); }
 55     void clear() { adj.clear(); }
 56     vector<edge>& operator [](int t) { return adj[t]; }
 57 };
 58
 59 template<class T> struct TreeArray {
 60     vector<T> c;
 61     int maxn;
 62     TreeArray(int n) { c.resize(n + 5); maxn = n + 2; }
 63     TreeArray() { c.clear(); maxn = 0; }
 64     void clear() { memset(&c[0], 0, sizeof(T) * maxn); }
 65     void resize(int n) { c.resize(n + 5); maxn = n + 2; }
 66     void add(int p, T x) { while (p <= maxn) { c[p] += x; p += lowbit(p); } }
 67     T get(int p) { T res = 0; while (p) { res += c[p]; p -= lowbit(p); } return res; }
 68     T range(int a, int b) { return get(b) - get(a - 1); }
 69 };
 70
 71 bool cmp(const pair<pii, int> &a, const pair<pii, int> &b) {
 72     return a.first.second < b.first.second;
 73 }
 74
 75 int a[maxn], b[maxn], c, n, k, L[maxn], R[maxn], vis[maxn], cc, out[maxn];
 76
 77 TreeArray<int> ts;
 78 pair<pii, int> in[maxn];
 79 Graph<int> G;
 80
 81 int find(int x) { return lower_bound(b + 1, b + c + 1, x) - b; }
 82
 83 void DFS(int u) {
 84     vis[u] = 1;
 85     L[u] = ++cc;
 86     b[cc] = a[u];
 87     for (int i = 0; i < G[u].size(); i++) {
 88         if (!vis[G[u][i]] || !vis[G[u][i]]) {
 89             DFS(G[u][i]);
 90         }
 91     }
 92     R[u] = cc;
 93 }
 94
 95 int main() {
 96     //freopen("in.txt", "r", stdin);
 97     int T, cas = 0, m;
 98     cin >> T;
 99     while (T--) {
100         scanf("%d%d", &n, &k);
101         for (int i = 1; i <= n; i++) {
102             scanf("%d", a + i);
103         }
104         G.clear();
105         G.resize(n);
106         for (int i = 1, u, v; i < n; i++) {
107             scanf("%d%d", &u, &v);
108             G.add(u, v);
109             G.add(v, u);
110         }
111         mem0(vis);
112         cc = 0;
113         DFS(1);
114         memcpy(a, b, sizeof(b));
115         sort(b + 1, b + n + 1);
116         c = unique(b + 1, b + n + 1) - b - 1;
117         for (int i = 1; i <= n; i++) {
118             a[i] = find(a[i]);
119         }
120         cin >> m;
121         for (int i = 0, x; i < m; i++) {
122             scanf("%d", &x);
123             in[i].first = make_pair(L[x], R[x]);
124             in[i].second = i;
125         }
126         sort(in, in + m, cmp);
127         G.clear();
128         G.resize(n);
129         ts.clear();
130         ts.resize(n);
131         mem0(vis);
132
133         int last = 0;
134         for (int i = 0; i < m; i++) {
135             for (int j = last + 1; j <= in[i].first.second; j++) {
136                 G.add(a[j], j);
137                 int sz = G[a[j]].size();
138                 if (sz >= k) {
139                     ts.add(G[a[j]][sz - k], 1);
140                     if (sz > k) {
141                         ts.add(G[a[j]][sz - k - 1], -2);
142                         if (sz > k + 1) ts.add(G[a[j]][sz - k - 2], 1);
143                     }
144                 }
145             }
146             out[in[i].second] = ts.range(in[i].first.first, in[i].first.second);
147             //cout << out[in[i].second] << " " << in[i].first.first << " " << in[i].first.second << endl;
148
149             last = in[i].first.second;
150         }
151         if (cas) cout << endl;
152         printf("Case #%d:\n", ++cas);
153         for (int i = 0; i < m; i++) {
154             printf("%d\n", out[i]);
155         }
156     }
157     return 0;
158 }

时间: 2024-09-30 23:59:31

[hdu4358]树状数组的相关文章

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

(POJ 3067) Japan (慢慢熟悉的树状数组)

Japan Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 29295   Accepted: 7902 Description Japan plans to welcome the ACM ICPC World Finals and a lot of roads must be built for the venue. Japan is tall island with N cities on the East coas

【二维树状数组】See you~

https://www.bnuoj.com/v3/contest_show.php?cid=9148#problem/F [题意] 给定一个矩阵,每个格子的初始值为1.现在可以对矩阵有四种操作: A x y n1 :给格点(x,y)的值加n1 D x y n1: 给格点(x,y)的值减n1,如果现在格点的值不够n1,把格点置0 M x1 y1 x2 y2:(x1,y1)移动给(x2,y2)n1个 S x1 y1 x2 y2 查询子矩阵的和 [思路] 当然是二维树状数组 但是一定要注意:lowbi

Vijos P1066 弱弱的战壕【多解,线段树,暴力,树状数组】

弱弱的战壕 描述 永恒和mx正在玩一个即时战略游戏,名字嘛~~~~~~恕本人记性不好,忘了-_-b. mx在他的基地附近建立了n个战壕,每个战壕都是一个独立的作战单位,射程可以达到无限(“mx不赢定了?!?”永恒[email protected][email protected]). 但是,战壕有一个弱点,就是只能攻击它的左下方,说白了就是横纵坐标都不大于它的点(mx:“我的战壕为什么这么菜”ToT).这样,永恒就可以从别的地方进攻摧毁战壕,从而消灭mx的部队. 战壕都有一个保护范围,同它的攻击

CF 313 DIV2 B 树状数组

http://codeforces.com/contest/313/problem/B 题目大意 给一个区间,问你这个区间里面有几个连续相同的字符. 思路: 表示个人用树状数组来写的...了解了树状数组的本质就行了. 当然用sum[r]-sum[l]也是可以的

Hdu5032 极角排序+树状数组

题目链接 思路:参考了题解.对询问进行极角排序,然后用树状数组维护一下前缀和即可. /* ID: onlyazh1 LANG: C++ TASK: test */ #include<bits/stdc++.h> using namespace std; #define lson l,m,rt<<1 #define rson m+1,r,rt<<1|1 typedef long long ll; const int maxn=1010; const int maxm=10

Curious Robin Hood(树状数组+线段树)

1112 - Curious Robin Hood    PDF (English) Statistics Forum Time Limit: 1 second(s) Memory Limit: 64 MB Robin Hood likes to loot rich people since he helps the poor people with this money. Instead of keeping all the money together he does another tri

【初识——树状数组】 区间求最值

说树状数组其实是一个索引表,但是是一个特殊的,树状的索引表,它利用了二进制的一些特性. 就区间求和的要求来说: 首先我们用a[]数组来存储原始数据.然后在a[]之上构造c[]数组来作为树状数组. 如图 这个图表示,当i为奇数时,c[i]中保存的都是a[i]本身.然后,c[2]中保存了a[1], a[2],共2个,c[4]中保存的是a[1], a[2], a[3], a[4],c[6]又是保存两个,c[5]和c[6].c[8]保存8个,c[1], c[2], c[3], c[4], c[5], c

树状数组求区间最大值

------  一直用 线段树 求区间最大值,想换种思路,用树状数组试试,肯定是可以的. 首先要对 树状数组的每个 i 所管理的区间有一定的理解.详见上篇博客: 树状数组(BIT)